// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package sign

import (
	_ "embed"

	"go.cypherpunks.su/keks"
	"go.cypherpunks.su/keks/schema"
)

//go:embed signed.schema.keks
var SignedSchemasRaw []byte

//go:embed pub.schema.keks
var PubSchemasRaw []byte

var (
	SignedSchemas map[string][][]any
	PubSchemas    map[string][][]any
)

func init() {
	var magic keks.Magic
	magic, SignedSchemasRaw = keks.StripMagic(SignedSchemasRaw)
	if magic != schema.Magic {
		panic("wrong magic in signed.schema.keks")
	}
	if err := keks.NewDecoderFromBytes(
		SignedSchemasRaw, nil,
	).DecodeStruct(&SignedSchemas); err != nil {
		panic(err)
	}

	magic, PubSchemasRaw = keks.StripMagic(PubSchemasRaw)
	if magic != schema.Magic {
		panic("wrong magic in pub.schema.keks")
	}
	if err := keks.NewDecoderFromBytes(
		PubSchemasRaw, nil,
	).DecodeStruct(&PubSchemas); err != nil {
		panic(err)
	}
}
